; -----------------------------------------------------------------------------
; RetroForth 7
; Generic Port	::  This is intended for use with OSes that use ELF and LIBC
; -----------------------------------------------------------------------------
include "macros.fasm"

format elf

extrn putchar
extrn getchar
extrn exit
extrn dlopen
extrn dlsym
	
public main
main:
	call init_retroforth
	call interpret
;---------------------------------------------------------------------
code 'bye', generic_bye
	push 0
	call exit
code 'emit', emit
	pusha
	push eax
	call putchar
	pop eax
	popa
	drop
	ret
code 'key', key
	dup
	call getchar
	ret
code 'LoadLibraryAs', load_dll
		embed 'zt-make'
		push eax
		drop
		upop edx
		pusha
		push edx
		call dlopen
		mov dword [tempX], eax
		add esp, 4
		popa
		dup
		mov eax, dword [tempX]
		dup
		pop eax
		embed 'zt-free'
		call create
		call comma
	next
	code 'MapFunctionAs', load_function
		embed 'zt-make'
		push eax
		drop
		upop ebx
		upop edx
		mov  edx, [edx]
		pusha
		push ebx
		push edx
		call dlsym
		mov dword [tempX], eax
		add esp, 8
		popa
		dup
		mov eax, dword [tempX]
		dup
		pop eax
		embed 'zt-free'
		call create
		call comma
	next
	code 'invoke', dll_invoke
		upop ecx
		cmp ecx, 0
		jz .run
	.chain:		push eax
		drop
		loop .chain
	.run:	call dword [eax]
	next
tempX dd 0
;---------------------------------------------------------------------
include "retroforth.asm"
